unit VypProg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Gauges,
  {  ,   }
  strbit32, Math;

   {  -      
           ( 
             
     ) }
const ChastObn : integer = 10000; 

type
  TFormIndProgr = class(TForm)
    Gauge1: TGauge;
    bnEndExecute: TBitBtn;
    procedure bnEndExecuteClick(Sender: TObject);
  private
    indvyp : boolean;
  public
   procedure KoderExecute(
     Matr: TStrings;      //  
     InpFileName,         //     
     OutFileName: String; //     
     ChislSk,             //   
     ZnSk : Integer);     //   
  end;

var
  FormIndProgr: TFormIndProgr;

implementation

{$R *.DFM}

procedure TFormIndProgr.KoderExecute(Matr: TStrings; InpFileName, OutFileName: String;
   ChislSk, ZnSk : Integer);
var PosSim, K, j, MaxSize : Integer;
    I: Byte;
    S : String;
    FIn,FOut : TBitFile;
    Registr : TStr_Bit;
    MatrixMass: array[1..16,1..16] of String[200];
    KoderMass: array[1..16] of TStr_Bit;
begin     {    }
  Show;      //      
  indvyp := True;
  Gauge1.Progress:= 0;
      {      }
  FIn := TBitFile.Create;
  FOut := TBitFile.Create;
  Registr := TStr_Bit.Create;
                                //   
 for i:=1 to ChislSk do begin
   S:=Matr[I-1];
   for j:=1 to ZnSk do begin
      S := Trim(S);
      K := Pos(' ',S)-1; if K= -1 then K := length(S);
      if K=0 then begin ShowMessage('   !');
                        Exit        end
             else MatrixMass[I,J]:=Copy(S,1,K);
      Delete(S,1,K);
 end; end;
  //       ( )
  MaxSize := 0;
  for J := 1 to ZnSk do begin
    K := 0;
    KoderMass[J] := TStr_Bit.Create;
    For PosSim := 1 to length(MatrixMass[1,J]) do
     for I:=1 to ChislSk do begin
      KoderMass[J][K] := Ord(MatrixMass[I,J][PosSim])-Ord('0');
      inc(K);               end;
    MaxSize:= Max(MaxSize,K);
   end;
 try                    {     }
 Registr.Init_0(MaxSize);
 try
  FIn.OpenBitFile(InpFileName,btOpenRead);
  FOut.OpenBitFile(OutFileName,btCreate);
  Gauge1.MaxValue := FIn.SizeOfFile div ChislSk;
  PosSim := 0;
  while FIn.ReadStr(ChislSk) = btOk do begin   //    
    If FIn.Size <> ChislSk then Break; //         
    for j:=1 to ChislSk do Registr.LastBitDisplase(FIn[j-1]); //  
    Inc(PosSim);
    if (PosSim mod ChastObn)=0 then begin  //      ChastObn  
      if indvyp = False then Break;  {     }
      Gauge1.Progress:=PosSim;
      Application.ProcessMessages; //     
     end;
    for j:=1 to ZnSk do FOut.WriteBit(Registr.ModReg(KoderMass[J]) ); //   
  end;
  Gauge1.Progress:=PosSim;
  ShowMessage('  .');
 Except on EFileBitError do ShowMessage('  .');
        on EFileBitZacr do ShowMessage('  .');
 end;
 finally  {   }
   FIn.CloseBitFile;     FOut.CloseBitFile;
   for J := 1 to ZnSk do KoderMass[J].Free;  //  ,    
 end;
   //  ,   
 Registr.Free;
 FIn.Free;
 FOut.Free;
 Close;
end;

procedure TFormIndProgr.bnEndExecuteClick(Sender: TObject);
begin
 indvyp := False;
end;

end.
